/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 * Copyright 2008 by Nakata, Maho
 * 
 * $Id: Clartg.debug.cpp,v 1.1 2009/12/21 05:43:30 nakatamaho Exp $ 
 *
 * MPACK - multiple precision arithmetic library
 *
 * This file is part of MPACK.
 *
 * MPACK is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * MPACK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with MPACK.  If not, see
 * <http://www.gnu.org/licenses/lgpl.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/
#include <mblas.h>
#include <mlapack.h>
#include <mpack_debug.h>

#include <blas.h>
#include <lapack.h>

#if defined VERBOSE_TEST
#include <iostream>
#endif

void
Clartg_test()
{
    int errorflag = FALSE;
    COMPLEX rtemp;
    COMPLEX f, g, sn, r;
    REAL cs;
    complex<double> fd, gd, snd, rd;
    double csd;
    int count = 100;

    while (count--) {
	set_random_number(&f, &fd);
	set_random_number(&g, &gd);
	Clartg(f, g, &cs, &sn, &r);
	zlartg_f77(&fd, &gd, &csd, &snd, &rd);

	if (num_diff(cs, csd) > EPSILON) {
	    errorflag = TRUE;
	    printf("Error1\n");
	}
	if (num_diff(sn, snd) > EPSILON) {
	    errorflag = TRUE;
	    printf("Error1\n");
	}

	if (num_diff(r, rd) > EPSILON) {
	    errorflag = TRUE;
	    printf("Error1\n");
	}

	f = 0.0;
	fd = 0.0;
	set_random_number(&g, &gd);
	Clartg(f, g, &cs, &sn, &r);
	zlartg_f77(&fd, &gd, &csd, &snd, &rd);

	if (num_diff(cs, csd) > EPSILON) {
	    errorflag = TRUE;
	    printf("Error1\n");
	}
	if (num_diff(sn, snd) > EPSILON) {
	    errorflag = TRUE;
	    printf("Error1\n");
	}

	if (num_diff(r, rd) > EPSILON) {
	    errorflag = TRUE;
	    printf("Error1\n");
	}

	if (num_diff(r, rd) > EPSILON) {
	    errorflag = TRUE;
	    printf("Error1\n");
	}

	g = 0.0;
	gd = 0.0;
	set_random_number(&f, &fd);
	Clartg(f, g, &cs, &sn, &r);
	zlartg_f77(&fd, &gd, &csd, &snd, &rd);

	if (num_diff(cs, csd) > EPSILON) {
	    errorflag = TRUE;
	    printf("Error1\n");
	}
	if (num_diff(sn, snd) > EPSILON) {
	    errorflag = TRUE;
	    printf("Error1\n");
	}

	if (num_diff(r, rd) > EPSILON) {
	    errorflag = TRUE;
	    printf("Error1\n");
	}
	if (errorflag == TRUE) {
	    printf("Clartg test failed...\n");
	    exit(1);
	}
    }
}
int
main(int argc, char *argv[])
{
#if defined ___MPACK_BUILD_WITH_GMP___
    int default_prec = 256;
    mpf_set_default_prec(default_prec);
    uniformrandom = new gmp_randclass(gmp_randinit_default);
#endif
#if defined ___MPACK_BUILD_WITH_QD___ || defined ___MPACK_BUILD_WITH_DD___
unsigned int oldcw;
fpu_fix_start(&oldcw);
#endif

    Clartg_test();
    printf("Clartg test passed...\n");

#if defined ___MPACK_BUILD_WITH_QD___ || defined ___MPACK_BUILD_WITH_DD___
fpu_fix_end(&oldcw);
#endif

  return(0);
}
